<?php

namespace App\Tasks\MassDelete;

use App\Models\Transaction;
use App\Tasks\MassInsert\MassInsert3Task;
use Carbon\Carbon;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\DB;

class MassDelete2Task
{

    /**
     * insert unit
     *
     *     100 ............ 0,018 s DONE
     *    1000 ............ 0,105 s DONE
     *   10000 ............ 0,938 s DONE
     *  100000 ........... 10,000 s DONE
     * 1000000 .......... 109,000 s DONE (1m 49s)
     */
    public function handle(int $count): void
    {
        (new MassInsert3Task)->handle($count);

        Transaction::query()
            ->select([
                'id',
            ])
            ->where('id', '>', 0)
            ->chunkById(1000, function ($transactions) {
                /** @var Collection $transactions */
                Transaction::query()
                    ->whereIn('id', $transactions->pluck('id'))
                    ->delete();
            });
    }
}
